2026-04-20 2.13.0 (API 0.9.70) released

2026-07-10 zzz
 * NetDB: Adjust exploration thresholds
 * Revert: NTCP: Release delayed buffer if connection was closed

2026-07-09 zzz
 * Data: Support writing UTF-8 RI options

2026-07-06 zzz
 * NetDB: Always create profiles for ff candidates in peer selector

2026-07-04 zzz
 * Tunnels: Increase per-tunnel bw limits

2026-07-03 zzz
 * Crypto: Fix unused TrustedUpdate.verify() method
 * Datagram2: Fix validation with offline keys
 * NTCP: Release delayed buffer if connection was closed
 * Profiles: Do not exclude L profiles if we are non-ff, low-bw
 * Transport: Fix wasUnreachable() removing expired entry from wrong map

2026-06-26 zzz
 * i2psnark: Reannounce early after transition from magnet mode to having metainfo

2026-06-20 zzz
 * Susimail: Add experimental standalone build option

2026-06-07 zzz
 * Crypto: Update bouncycastle MLKEM to 1.84

2026-06-06 zzz
 * Console: Change version field in lookup form to a dropdown

2026-06-03 zzz
 * Tunnels:
   - Increase conn limits for tunnel rejection again
   - Reduce bw request if we have no tunnels (congestion avoidance)
   - Extend idle tunnel timeout to 2.5 minutes
   - Remove config to disable tunnel testing
   - Continue tunnel testing during graceful shutdown

2026-06-01 zzz
 * Streaming: Remove deprecated/unused session key/tag methods

2026-05-29 zzz
 * Test: LocalClientManager fixes/improvements

2026-05-28 zzz
 * Console: Add configurable router nickname to summary bar
 * Tunnels:
   - Send IBGW limit request to correct hop
   - Don't request limit for client tunnels
   - Don't use factor for per-tunnel limiters
   - Don't test inbound tunnels that recently received data

2026-05-27 zzz
 * Console: Change client tunnel display data from usage to bandwidth
 * Jetty: Add optional feature to gzip request logs on rollover
 * Transport: Increase some conn limit thresholds
 * Tunnels:
   - Request IBGW limits on all IB tunnels (prop. 168)
   - Implement per-tunnel bandwidth limiting (prop. 168)
 * Util: Fix eepget/eephead CLI not honoring timeout option

2026-05-25 zzz
 * NetDB: Note RI store successful in profile when we skip verification

2026-05-24 zzz
 * NetDB: Increase max early expiration probability for U RIs
 * NTCP2: Reduce max connections for inbound to leave room for outbound
 * PeerManager: fix getIsActive inversion
 * Router: Reduce conn limit threshold for D cap again
 * SSU2: Revert token time calculation change that messed up expiration times

2026-05-23 zzz
 * SSU2: Token improvements

2026-05-21 zzz
 * Profiles: Reduce new profile creation

2026-05-20 zzz
 * Profiles: Remove unused counters of unprompted DB stores

2026-05-18 zzz
 * Console: Add pagination for all-profiles tab
 * SSU2: Peer test result fix as Alice when we never got Charlie's RI

2026-05-17 zzz
 * i2psnark:
   - Add check for empty filenames
   - Fix check for existing base file when adding via create form
   - Use unfiltered base file name if it exists

2026-05-16 zzz
 * Transports: Reduce min downtime to rekey transport keys

2026-05-15 zzz
 * Console: Don't display hide/show news links on /configupdate
 * i2psnark: Increase max form keys
 * Router: Fix rare NPE at startup in InNetMessagePool
 * Susimail: Remove static login nonce

2026-05-12 zzz
 * SSU2: Require three consecutive peer tests for IPv6 state changes

2026-05-11 zzz
 * SSU2: Require two peers from different /16s to change address

2026-05-10 zzz
 * I2NP: Add missing length checks in readMessage() methods
 * Util: More constant-time comparisons

2026-05-09 zzz
 * i2ptunnel: Refactor list page forms

2026-05-08 zzz
 * SSU2: Resurrect hole punch throttling as Charlie
 * Util: Use constant-time comparison in various password checkers

2026-05-07 zzz
 * i2psnark, i2ptunnel: Refactor nonces
 * Transport: Disable SSU bid adjustment for new routers as of next release

2026-05-06 zzz
 * Console:
   - Validate Origin header
   - Refactor nonces
   - Add search option for PQ SSU2

2026-05-01 zzz
 * Transport: Fix PQ SSU2 I2NP block header

2026-05-01 zzz
 * Console: Specify full path to Windows service scripts
 * Crypto: Use constant-time modPow() for ElG private key operations
 * I2CP: Wait for queue space on internal queue close()
 * i2psnark: Remove support for ancient name.utf-8 and path.utf-8 metainfo entries
 * Transport:
   - Fail-fast if NTCP2 msg 2 padding length is too much
   - Increase SSU2 nonce replay cache size

2026-04-30 zzz
 * Util:
   - Revert change causing failed decode of compressed IPv6 addresses
   - Update minidns to 1.1.1
   - Update json-simple to 2.3.1

2026-04-27 zzz
 * i2ptunnel, I2CP, SAM: Add delays on auth failure

2026-04-26 zzz
 * i2psnark: Fix autostart of completed torrents when added to the directory
 * Update: Randomize the order of news URLs when fetching

2026-04-25 zzz
 * Addressbook: Do not re-add hosts deleted in router address book
 * Console: Sanitize plugin name in ConfigClientsHandler
 * Crypto:
   - Refactor Noise initialization to use enums
   - Change RFC 7748 DH error to a checked exception
   - Disallow DSA-SHA1 signing k=q
 * I2CP: Add missing max length check on alternate readMessage() path
 * I2CP, SAM: Support lookup of ls2 options (proposal 167)
 * i2ptunnel: SOCKS4a limit max string length
 * Router: Don't use InetAddress.getByName() for blocklist IP conversion
 * Spotbugs fixes
 * Transport:
   - Add support for SSU2 PQ hybrid (proposal 169)
   - Fail-fast if NTCP2 msg 1 padding length is too much
   - Fix off-by-one check of SSU2 max fragment number

2026-04-20 2.12.0 (API 0.9.69) released

2026-04-12 zzz
 * Crypto:
   - Use constant-time comparison in ElG decrypt and HMAC verification
   - Check for zero output in X25519 DH as recommended by RFC 7748

2026-04-12 zzz
 * Install: Disable add'l params to i2prouter script (GH #135)

2026-04-04 zzz
 * i2ptunnel: Catch corrupt HTTP responses sooner

2026-04-02 zzz
 * GeoIP 2026-04-01

2026-03-31 zzz
 * Console: Add language selection presence to translation report

2026-03-27 zzz
 * SAM:
   - Use session for b32 lookups if available
   - Error message for NAMING LOOKUP NAME=ME out-of-session

2026-03-25 zzz
 * I2CP: Fix LS2 options not being updated on subsession

2026-03-24 zzz
 * I2NP: HostReplyMessage updates for proposal 167 (WIP)

2026-03-23 zzz
 * Console, eepsite: HTML fixes for Weblate
 * UPnP: Fail fast if no local addresses, don't blame on port conflict

2026-03-21 zzz
 * Console: Show conn limits on peer status page
 * NetDB: Force L cap if very low max tunnels
 * SSU2: Set peer test result to firewalled if no peers available to test

2026-03-19 zzz
 * Stats: Fix 60s stat getAverage() returning 20% high

2026-03-17 zzz
 * Console: Fix classloader issues when starting/installing plugins
 * NetDB: Publish D cap if near conn limits

2026-03-13 zzz
 * Console: Mark LS1 encrypted leasesets as deprecated
 * Debian: Require libjetty12-java 12.0.32-2 for trixie/resolute

2026-03-12 zzz
 * ISJ: Fail peer if it doesn't support ElG or Ratchet

2026-03-10 zzz
 * Jetty: Rename cgi-context.xml to cgi-context.xml.disabled

2026-03-06 zzz
 * NetDB: ISJ fixes for client replies going to main db

2026-03-05 zzz
 * Crypto: Fix SSU2 MLKEM Noise init (WIP)

2026-03-04 zzz
 * i2ptunnel: Don't force-migrate 4 or 4,0 to 6,4

2026-02-28 zzz
 * I2CP: Force LS2 even for ElG-only
 * SSU2: Fix rare NPE in PeerTestManager.ContinueTest

2026-02-26 zzz
 * Console: Limit banlist output, add page links
 * Transport: Increase max padding for NTCP2 non-PQ

2026-02-21 zzz
 * Crypto: Noise initialization for SSU2-PQ (WIP)

2026-02-20 zzz
 * Transport: Support any outbound connection NTCP2-PQ version

2026-02-19 zzz
 * Transport: Add support for PQ NTCP2 (Prop. 169)

2026-02-18 zzz
 * Console: Add display of average bandwidth per tunnel

2026-02-17 zzz
 * Build: Fix Jetty javadoc link, update JavaSE javadoc link, update package-lists
 * Console: Fix overstatement of lifetime tunnel bw usage
 * Tunnels:
   - More BW params handling (Prop. 168)
   - Change tunnel bw rate stat from 5m to 10m
   - Better average of per-tunnel bw by including current tunnels

2026-02-16 zzz
 * Router: Limit max banlist size

2026-02-15 zzz
 * Console: Add netdb search option for NTCP2 PQ transports

2026-02-14 zzz
 * Console:
   - Show country map for netdb search results
   - Use unique cookie per-install
 * Datagrams: Use smaller initial buffer size in DG1 maker
 * i2psnark: Clear bw limiters on session stop

2026-02-10 zzz
 * i2psnark standalone: Build fix

2026-02-09 2.11.0 (API 0.9.68) released

2026-02-08 zzz
 * Debian: Remove resolute jars from jammy source
 * Router: More robustness fixes
 * SSU2: Increase IP table size

2026-02-06 zzz
 * Debian: Resolute/trixie fixes

2026-02-05 zzz
 * Debian: Package fixes
 * NetDB: Tweak RI drop probabilities

2026-02-04 zzz
 * Router: Robustness fixes

2026-02-03 zzz
 * Debian: Jammy build fixes

2026-02-02 zzz
 * Debian: Updates for trixie/resolute

2026-01-20 zzz
 * i2psnark: Increase max piece size to 64 MB

2026-01-14 zzz
 * Console, docs: Change canonical domain to i2p.net

2026-01-01 zzz
 * Increase min router version for tunnels and netdb

2025-12-07 zzz
 * NetDB: Disable ExploreJob in test mode

2025-12-05 zzz
 * Build: Javadoc fixes

2025-12-03 zzz
 * i2psnark, i2ptunnel: Migrate to encTypes 6,4

2025-12-01 zzz
 * Console: Fix classloader issue starting webapps from UI
 * Tunnels: Increase per-hop TunnelDataMessage expiration

2025-11-29 zzz
 * Console: Add config to disable bubbles
 * Wrappper: Increase max mem to 512 MB (new installs only)

2025-11-24 zzz
 * Build: Non-Deb Jetty build fix

2025-10-25 zzz
 * Debian: Preliminary updates for Jetty 12

2025-10-22 idk
 * Ratchet: Add ML-KEM keypair precalc thread

2025-10-19 idk
 * Jetty 12.0.28 and eepsite xml migration

2025-10-11 idk
 * SAM: Add support for Datagram 2/3 (Proposal 163)

2025-09-08 2.10.0 (API 0.9.67) released

2025-09-08 idk
 * Pull translations from Transifex

2025-09-05 zzz
 * Translations update

2025-09-03 zzz
 * Console: New partial Icelandic translation

2025-09-01 zzz
 * GeoIP 2025-09-01

2025-08-27 zzz
 * NetDB: Preliminary fix for exploratory lookups

2025-08-26 zzz
 * NetDB:
   - Fix direct lookups
   - Handle broken direct lookups
   - Drop exploratory lookups from floodfills

2025-08-21 zzz
 * Build: Remove ancient, unused admin code (Github PR #116)
 * Console: Don't bypass nonce check when password is enabled (Github PR #118)

2025-08-20 zzz
 * Transports: Reduce ban time for slow routers if floodfill

2025-08-17 zzz
 * NetDB: Exploration improvements and fixes
 * Router: Fix PublishRouterInfoJob sometimes not getting started
 * SSU2: Fix last receive time tracking

2025-08-10 zzz
 * Console:
   - Hide b32 link on netdb LS tabs for encrypted LS
   - Fix layout for final LS data section on netdb LS debug tab
 * i2psnark: Handle UDP trackers in magnet links

2025-08-09 zzz
 * Console: Fix NPE on netdb LS debug tab rendering encrypted LS

2025-07-27 zzz
 * Crypto: Reduce YK precalc pool size
 * I2CP: Stub out new HostLookup types for service records (proposal 167)
 * i2ptunnel: Expose 6,4 option to non-advanced-config
 * Tomcat 9.0.107

2025-07-17 zzz
 * I2CP: Client-side destroy session fixes

2025-07-04 zzz
 * i2psnark: UDP announce fixes
 * SSU: Increase inbound ban time
 * Util: Android Java version detection improvements

2025-07-01 zzz
 * Streaming: Allow configured max window size higher than default

2025-06-30 zzz
 * I2CP: Don't send multiple SetDate messages to sessions with subsessions

2025-06-26 zzz
 * i2psnark: UDP announce fixes
 * Router: Reduce and document the banlist-forever threshold

2025-06-24 zzz
 * Crypto: Add support for MLKEM PQ hybrid ratchet (Proposal 169) (PR 517)

2025-06-21 zzz
 * i2psnark: Update UDP announce support (Proposal 160) (PR 504)

2025-06-18 zzz
 * I2CP: Add asynch lookup API (PR 511)

2025-06-17 zzz
 * Router: Store ident and hash at startup, remove lock (PR 507)
 * Transports: Remove unused ElG DH builder (PR 508)

2025-06-15 zzz
 * I2CP: Add support for service records (Proposal 167) (PR 501)
 * SSU2: Remove old active throttle code (PR 505)
 * Stats: Remove old stat log feature (PR 503)

2025-06-05 zzz
 * i2ptunnel: Remove delay before flushing output

2025-06-04 zzz
 * Console: Add sidebar warning about Java 17

2025-06-02 2.9.0 (API 0.9.66) released

2025-05-30 zzz
 * Pull translations from Transifex

2025-05-19 zzz
 * Log warning on upcoming Java 17 requirement

2025-05-14 zzz
 * i2psnark: Tracker list updates

2025-05-09 zzz
 * Console: Only show restart required on /configi2cp when interface changes
 * I2CP, SOCKS: Log IP on authentication failure
 * i2psnark: Change search of multiple tokens from OR to AND

2025-05-07 zzz
 * i2ptunnel, console: Log IP on authentication failure

2025-05-05 zzz
 * Console: Fixup bug reporting links

2025-05-04 zzz
 * Plugins: Sort plugins.config when saving
 * Router: Fix rare deadlock at shutdown

2025-05-03 zzz
 * Console: Add new hostname to addressbook bubble if count is 1
 * NTCP: Ban and do probing resistance on MSB check fail

2025-05-02 zzz
 * CLI: Show deprecated types in privatekeyfile and su3file help
 * SusiDNS: Show correct enctype on details page

2025-05-01 zzz
 * NTCP:
   - Temporary ban of IP sending corrupt SessionRequest
   - Increase temporary ban time
   - Remove old NTCP 1 handshake buffers

2025-04-30 zzz
 * I2CP: Datagram 2/3 preliminary support (Proposal 163)
 * Jetty: Migrate jetty.xml files at startup
   to fix id and DTD issues for existing installs

2025-04-29 zzz
 * Console: Logs page improvements

2025-04-27 zzz
 * i2psnark: Remove ElGamal peer support

2025-04-26 zzz
 * i2ptunnel: Canonicalize Host header at the server proxy

2025-04-25 zzz
 * Util: Add ability to force IPv6 for SSLEepGet

2025-04-24 zzz
 * Blockfile: Catch unchecked exceptions thrown from value deserializers
 * CLI: Add -6 flag to force IPv6 reseed test
 * i2ptunnel: Force CSS load before render on proxy error pages
 * NetDB: Add new reseed

2025-04-23 zzz
 * i2psnark standalone: Change Ref id to refid in Jetty config file

2025-04-20 zzz
 * Build: Change Ref id to refid in Jetty config files (new installs only)
 * Use Long.compare() in comparators
 * i2psnark:
   - Remove outstanding requests from pieces when connection is replaced
   - Show lifetime download rate since added on details page
   - Show current tunnel config in dropdowns even if outside normal range
   - Add 2nd tie break for peer count when sorting by status
   - Make standalone buildable on windows without zip
 * SusiDNS: Add b32 and dest reverse lookups

2025-04-16 zzz
 * Tunnels: Implement proposal 168 (part 1)
   - Add bw params to build requests
   - Add bw param to build reply
   - Reject build request if cannot allocate min bw
   - Track allocated bw in HopConfig
   - Track total allocated bw in TunnelDispatcher

2025-04-13 zzz
 * Console:
   - Adjust map Mercator coordinates
   - Ensure smaller country circles are above larger ones
   - Remove single-point countries on map

2025-04-12 zzz
 * Console: Display changelog in html

2025-04-10 zzz
 * i2ptunnel: Reduce HTTP server thread usage
   - Increase performance and properly enforce limits.
   - Handle all GET and HEAD requests in the handler thread
   - Handle POST and CONNECT in threads from the server pool, to not bypass server thread limits
   - For POST and CONNECT, the opposite-direction (Sender) thread is still run in the client pool
   - Ensure the server thread limit is at least the streaming max connections limit so we don't run out

2025-04-09 zzz
 * Console: Use Basic auth for prometheus plugin
 * NetDB:
   - Fix auto-ff, broken when SSU1 was disabled
   - Maintain ff after restart when configured for auto

2025-04-08 zzz
 * Console: Add world map with locations of routers and tunnels
 * NetDB: Don't store unreachable routers to disk
 * Wrapper:
   - Update wrapper to 3.5.60
   - Remove Linux PPC 32-bit BE wrapper files
   - Remove Solaris Sparc 32-bit wrapper files
   - Add patch to fix breakage on Debian xx-ea Java versions

2025-04-04 zzz
 * Crypto: Use /dev/random PRNG by default

2025-03-31 zzz
 * Console: Remove redundant LS rendering code

2025-03-30 zzz
 * i2psnark:
   - Increase thumbnail size
   - DTG/Bubble notifications on torrent add failures
 * NetDB: Don't store old router versions to disk

2025-03-29 2.8.2 (API 0.9.65) released

2025-03-28 zzz
 * Update translations

2025-03-26 zzz
 * i2ptunnel: Clear bubble count when clearing status messages

2025-03-22 zzz
 * Router: Prevent double-free of SHA256 instances from Noise

2025-03-21 zzz
 * Build: Add cs man pages, cs, pt_BR, zh_TW eepsite help pages

2025-03-19 zzz
 * Build: Remove more files from Debian source tarball
 * Console: Reduce memory usage in BanlistRenderer
 * i2psnark: Use torrent name instead of torrent file name in notifications
 * i2ptunnel: Version the proxy CSS in more places

2025-03-17 2.8.1 (API 0.9.65) released

2025-03-14 zzz
 * Update translations

2025-03-08 zzz
 * Tunnels: Fix UOE on timeout of OB client tunnel test

2025-03-07 zzz
 * installer: Add logo to first panel, add progress bar

2025-03-06 zzz
 * i2ptunnel: Change encryption type radio to dropdown, update tooltips

2025-03-01 zzz
 * Console: Add error page test servlet
 * GeoIP 2025-03-01
 * Installer: Fix installation to path with spaces

2025-02-28 zzz
 * Transport: Ban routers with RI format errors if signature verifies

2025-02-25 zzz
 * Console: Move certs page to a debug page tab
 * Streaming: Prevent AIOOBE when verifying large signed packets
 * SusiDNS: Add bubble support

2025-02-24 zzz
 * Console: Improve writing efficiency

2025-02-23 zzz
 * SusiDNS: Reduce memory usage in AddressBean
 * Tests: Fix build

2025-02-22 zzz
 * Console: Add support for notification bubbles

2025-02-21 zzz
 * Client: Deprecate getters for unused encryption private key
 * i2psnark: Set bulk profile
 * i2ptunnel: Set bulk profile for servers
 * Tunnels: Prep for bw params (prop. 168)

2025-02-20 zzz
 * Tunnels: Fix tunnel test for OB client tunnels

2025-02-17 zzz
 * i2ptunnel: Add .i2p.alt support to HTTP and SOCKS client tunnels (MR 222)
 * SusiDNS: Implement sort-by-added-date (MR 231)

2025-02-14 zzz
 * SusiDNS: Navbar CSS fixes/tweaks

2025-02-11 zzz
 * i2ptunnel: Proxy error page improvements

2025-02-10 zzz
 * Router: Unused stats removal
 * Transport: More SSU1 code removal

2025-02-09 zzz
 * SusiDNS: Remove null checks in comparator

2025-02-07 zzz
 * Build: Check for mismatched version in Izpack config files
 * Crypto:
   - Allow external use of pooled SHA256 instances
   - Use pooled SHA256 instances in Noise lib
 * Data:
   - Fix compression of RouterIdentities
   - Check key order when parsing RI mappings and fail-fast if out-of-order
 * i2psnark: Reduce PeerCoordinator CHECK_PERIOD interval
 * Transport:
   - Remove old NTCP 1 stats
   - SSU 1 removal part 10/n (UDPPacket)

2025-02-04 2.8.0 (API 0.9.65) released

2025-02-03 zzz
 * Data: Fix compressible padding detection and expansion
 * NetDB: Fix reversed conditional in ExpireLeasesJob.java

2025-01-31 zzz
 * Pull translations from Transifex

2025-01-30 zzz
 * NetDB: Debounce RI publishing at startup
 * susidns: Dark theme fixes/tweaks

2025-01-29 zzz
 * NetDB: Reseed update

2025-01-28 zzz
 * NetDB: More RI publishing improvements

2025-01-27 zzz
 * NetDB: RI publishing improvements

2025-01-26 zzz
 * Transport: Increase min peer test version

2025-01-21 zzz
 * Util: Recognize zen5 processors

2025-01-20 zzz
 * Build: Create jammy build to handle Jetty API change (Gitlab #496)

2025-01-18 zzz
 * BW Test:
   - Disable some status messages
   - Set connection timeout
   - Tag status strings for translation
   - Unused code removal
   - Use IP provided by test server

2025-01-17 zzz
 * i2psnark: Require POST on forms
 * susidns: Require POST on forms

2025-01-12 zzz
 * CLI: Improve selfsignedgenerator usage help

2024-12-26 zzz
 * NetDB:
   - Reduce max ff response time
   - Base lookup timeout on peer's average response time
 * Profiles: Remove unused 10m and 24h rates for DB response time

2024-12-18 zzz
 * NetDB: Aggressive expire for leasesets when over limits

2024-11-29 zzz
 * Build: Prep for izpack 5.2.3 (Github #86)
 * Transport: Better message on UPnP tab when enabled but fails to start (Github #84)

2024-11-28 zzz
 * Build: Suppress JNI warnings from Java 24 for CLI and i2psnark-standalone

2024-11-26 zzz
 * Console: Move jar dump link from summary bar to debug page tab
 * New complete Gan Chinese translation

2024-11-17 zzz
 * Profiles: Extend time to treat E routers as severely congested
 * Streaming: Reduce batch delay

2024-11-14 zzz
 * Router: Change cap for sym. nat

2024-11-08 zzz
 * SSU2: Don't send separate ack for relay intro (Gitlab MR #220)

2024-11-04 zzz
 * Console: Increase interval change for larger/smaller interval buttons on /graph
 * Router: Periodically recheck family of negative cached RIs
 * SSU2:
   - Detect and drop dup relay messages as Bob
   - More SSU1 code removal

2024-11-02 zzz
 * Console: remove dark theme override of router log colors
 * SSU2: Hopefully fix rare deadlock

2024-10-22 zzz
 * Console: Merge in more upstream rrd4j changes for 3.10

2024-10-08 2.7.0 (API 0.9.64) released

2024-10-08 idk
 * Fix failing tests

2024-09-21 zzz
 * streaming: Allow i2p.streaming.profile != 1

2024-09-20 zzz
 * i2psnark: Fix broken infohash after torrent edit (Gitlab MR #216)

2024-09-10 zzz
 * Console: Refactor netdb search (Gitlab MR #217)

2024-08-31 zzz
 * Console: Consolidate hash comparators (Gitlab MR #214)

2024-08-23 zzz
 * I2CP: Don't include lease about to expire in LS request

2024-08-19 zzz
 * i2psnark: Fix clear messages button (light theme) (Gitlab #479, Github #81)

2024-08-17 zzz
 * Naming: lookup fixes

2024-08-16 zzz
 * NetDB, I2CP: Fix tunnels going yellow for several minutes (Gitlab #487)
 * SVG: Optimize output for horizontal/vertical segments in paths

2024-08-12 zzz
 * Util: Add temp dir timestamper to prevent deletion by systemd

2024-08-11 zzz
 * NetDB:
   - Don't expire entries in test mode
   - Don't immediately expire entries for Android

2024-08-09 zzz
 * i2psnark: Reduce minimum banwdith, reduce max connections if low bandwidth
 * i2psnark, susimail: Normalize strings when searching (Gitlab #488)
 * susimail: Fix searches for multiple terms
 * Tunnels: Do not select ElG routers for tunnels
 * Util: Reduce number of PRNG output buffers

2024-08-07 2.6.1 (API 0.9.63) released

2024-08-07 idk
 * update geoip database

2024-07-25 zzz
 * Console:
   - Add translation status report (Gitlab MR !207)
   - Convert graphs to SVG (Gitlab MR !208)
   - Enable compression of js and svg files
 * i2ptunnel: Additional fixes for invalid entries in filter file (Gitlab #483)
 * imagegen: Convert identicons to SVG
 * Installer: Fix some izpack5 translated languages
 * rrd4j: More optimizations for graph generation
 * Util: Add new processors for CPUID

2024-07-19 2.6.0 (API 0.9.63) released

2024-07-19 idk
 * Fix failing integration tests

2024-07-15 zzz
 * Pull translations from Transifex

2024-07-06 zzz
 * Console: Fix tunnel.Bps.* graphs sometimes not rendering

2024-07-05 zzz
 * I2CP: Send DestroySessionMessage with dummy SessionID if unset
 * imagegen: QR code text size/placement tweaks

2024-07-02 zzz
 * Jetty: Don't show null exception message in XSSFilter

2024-07-01 zzz
 * Tunnels: Peer selection tweak

2024-06-30 zzz
 * i2psnark: Fix alignment of torrent names (light/vanilla themes) (Github #76)
 * Router: Remove ancient test code for variable leasesets
 * Tunnels: Remove old check for buggy routers now that MIN_VERSION is higher
 * Util: Don't classify ARM servers as slow (Github #77)

2024-06-29 zzz
 * i2psnark: Fix config display of limit for max up bw after restart (Github #75)
 * Util: Remove discontinued DoH server (Github PR #79)

2024-06-27 zzz
 * I2CP: Increase % of router bandwidth reported to clients

2024-06-26 zzz
 * Console: Fix typo in Permissions-Policy header

2024-06-20 zzz
 * susimail: Update size limits to match current postman limits

2024-06-20 zzz
 * i2ptunnel: Reduce severity of access filter errors (Gitlab #483)

2024-06-11 zzz
 * Build: Put JspC wrapper in its own jar, used only at build time

2024-06-10 zzz
 * Router: Increase min version for floodfills, tunnels, reseed

2024-06-04 zzz
 * Console: Add js refresh on /graphs (Gitlab MR !199)
 * i2psnark:
   - Fix leaked requests, partial pieces, and temp files (Gitlab MR !203)
   - Make PEX more efficient
 * Reseed: Increase min version when creating bundles; CLI improvements
 * Router: Add synthetic stats for client and expl. build success rate

2024-06-01 zzz
 * I2CP: Store local destination in lookup cache (Gitlab #482)
 * Router: Don't update rates for full stats when not enabled
 * Transport: Remove SSU1 code from UDPTransport (Gitlab MR !197)

2024-05-29 zzz
 * Console: More graph improvements

2024-05-28 zzz
 * Console: Graph improvements

2024-05-26 zzz
 * Susimail: CSS fixups (dark theme)

2024-05-23 zzz
 * i2ptunnel: Fix CTCP ACTION (Gitlab #481)

2024-05-21 zzz
 * Build: maketorblocklist.sh fixups (Gitlab MR !198 by kytv)
 * Susimail: XHR search (Gitlab MR !196)
 * Transport: Remove SSU1 code from IES/OES/PacketReader/HMAC (Gitlab MR !197)
 * Tunnels: Don't parse messages at the OBEP (Gitlab MR !194)

2024-05-19 zzz
 * i2psnark: Fix NPE when attempting to create torrent with too many files

2024-05-18 zzz
 * Console: js global scope fixes (Gitlab MR !195)
 * Transport: Remove SSU1 code from PacketBuilder/PeerState/OMF (Gitlab MR !193)

2024-05-17 zzz
 * Build: Add script to make Tor blocklist

2024-05-16 zzz
 * I2CP: Hopefully fix rare NPE
 * Util: Remove ST2 timers from queue on cancel

2024-05-15 2.5.2 (API 0.9.62) released

2024-05-14 zzz
 * i2ptunnel: Fix keepalive bug causing truncation of chunked content
 * Pull translations from Transifex
 * Router: Update Tor blocklist

2024-05-12 zzz
 * Console: Update rrd4j to 3.9.1 preview

2024-05-08 zzz
 * i2ptunnel: Fix custom options form width (light theme)
 * Router: Publish G cap if symmetric natted
 * Tunnels: Validate peer RI expiration in TunnelPeerSelector

2024-05-06 2.5.1 (API 0.9.62) released

2024-05-05 zzz
 * NetDB: Various fixes and adjustments
 * Pull translations from Transifex

2024-05-03 zzz
 * NetDB: Don't lookup RI if temp. banlisted
 * Router: Add Tor blocklist
 * Tunnels: OBEP distributor: Check and charge RI lookup bandwidth

2024-05-02 zzz
 * Profiles: Fixes for firstHeardAbout and/or lastHeardAbout being zero

2024-05-01 zzz
 * NetDB:
   - Limit number of DSRM entries to follow
   - Deny old ANY lookup type to non-ff

2024-04-27 zzz
 * Sybil: Disable IP checks for now

2024-04-26 zzz
 * Susimail: Search fixes

2024-04-25 zzz
 * Susimail: Add search box (Gitlab MR !190)
 * Transport: Remove SSU1 code from IMF/IMS (Gitlab MR !189)

2024-04-22 zzz
 * Addressbook: Use standard time formatting for log
 * Profiles: Don't update last heard time on tunnel failure
 * Transport: Remove SSU1 code from PeerTest and IntroductionManager (Gitlab MRs !185, !186)

2024-04-17 zzz
 * Build: Update to Tomcat 9.0.88

2024-04-15 zzz
 * Susimail: Don't show multipart/related CID images as attachments also

2024-04-13 zzz
 * Susimail:
   - Reply-all improvements
   - Add sender name to default config, use when replying
   - Don't show attachment flag for HTML emails
   - Increase compose form width (dark theme)
   - Add missing div ids for DnD
   - Improve validateAddress()

2024-04-08 2.5.0 (API 0.9.62) released

2024-04-05 zzz
 * Susimail:
   - Fix truncation of quoted-printable encoded attachments
   - Fix loading mail bodies in non-inbox/drafts folders
 * Translation updates

2024-04-04 zzz
 * Susimail:
   - Only parse mail headers once
   - Fix initialization of textarea height
   - Fix 413 error forwarding email with attachments
   - Fix forwarding email with attachments lacking specified encoding
   - Fix forwarding html-only email

2024-03-26 zzz
 * NetDB: Store message handling changes
 * Transports: Incoming connection checks
 * Tunnels:
   - Refactor message distribution
   - Tunnel test changes

2024-03-23 zzz
 * i2psnark: Preserve private=0 in torrent files

2024-03-20 zzz
 * New translations for some subsystems: Japanese, Hungarian, Slovenian, Estonian

2024-03-09 zzz
 * i2psnark: Fix buttons on torrent details page (JRE 21)

2024-03-03 zzz
 * i2psnark:
   - Fix DnD js syntax error
   - Add torrent section and config page CSS fixes (non-default themes)

2024-03-01 zzz
 * SSU2: Cancel peer test if Bob picked a Charlie without a B cap

2024-02-29 zzz
 * SSU2: Treat IPv6 peer test result as unknown if no response from firewalled Charlie

2024-02-26 zzz
 * Console: Use same color for visted links (dark theme)
 * i2psnark:
   - Don't allow changing data dir when connected
   - Delete all torrents except magnets when changing data dir

2024-02-25 zzz
 * SSU2:
   - Increase min version for peer test
   - Update last rcv time when receiving data, not acks

2024-02-14 zzz
 * i2ptunnel: Implement server-side persistence (Gitlab MR !181)

2024-02-02 zzz
 * i2ptunnel: Implement client-side persistence (Gitlab MR !176)
 * susimail: Add support for HTML email (Gitlab MR !177)

2024-01-31 zzz
 * CLI: Add sdns stamp decoder

2024-01-30 zzz
 * Naming: Add .i2p.alt support
 * Util: DoH server list update

2024-01-29 zzz
 * Crypto:
   - More efficient enum lookup by code
   - Verify RSA sigs after signing
 * i2psnark: Sanitize unicode LTR/RTL control chars
 * Util: Add .alt to selfsigned cert alt names

2024-01-28 zzz
 * Build: Update gradlew to 8.5 (Gitlab MR !180)

2024-01-27 zzz
 * Console: Update RRD4J to 3.9 (Gitlab MR !178)
 * Transport: Remove SSU1 code from EstablishmentManager (Gitlab MR !179)

2024-01-23 zzz
 * i2ptunnel, susidns: Fix IDN decoding for newer codepoints

2024-01-22 zzz
 * i2psnark: Add drag-and-drop for torrent files and links (Gitlab MR !165)
 * susimail: Add drag-and-drop for attachments (Gitlab MR !171)

2024-01-15 zzz
 * I2CP: Prevent loopback messages to same session (i2pd Github #2005, Gitlab MR !173)
 * i2psnark: Bandwidth limiter improvements (Gitlab MR !164)

2024-01-14 zzz
 * Data: Store compressed RI and LS in compressed form (Gitlab MR !171)
 * i2ptunnel:
   - Add utilities for keepalive (WIP) (Gitlab MR !166)
   - Don't send HTML errors on CONNECT sockets (Gitlab MR !175)
 * Transport: Remove SSU1 code from PacketHandler (Gitlab MR !174)

2024-01-10 zzz
 * Console: Fix iframe size issues (Gitlab MR !160)
 * Susimail: Add markdown js for plain text content (Gitlab MR !161)
 * SSU2: Delay sending relay tag (Gitlab MR !169)

2024-01-08 zzz
 * Transport: Ignore SSU1 enable config

2024-01-02 zzz
 * Console: News fetch improvements (Gitlab MR !163)
 * Router: Enforce max RI size (Gitlab MR !168)
 * Susimail: Speed up initial loading (Gitlab MR !162)
 * Tunnels: Peer selection adjustments (Gitlab MR !167)

2023-12-23 zzz
 * Susimail:
   - Add dropdown on login page for multiple accounts
   - Add logo to footer
   - Add regex util (WIP)
   - Auto-resize compose box
   - Extract multipart type and content id (WIP)
   - Logging enhancements on file read failures
   - Put error messages at the top
   - Show size and thumbnail of draft attachments
   - Show user name on folder view
 * Util: Move SyntheticREDQueue from router to core

2023-12-22 zzz
 * Blockfile: Fix bug in unused getNames()
 * Console: Fix encoding issues in persisted news
 * I2CP: Add router rates to bandwidth limits message
 * i2psnark: Adjust max peers for small torrents
 * i2ptunnel:
   - Change return code for host-not-in-addressbook to 502
   - Log correct server host/port on error when there are multiple targets configured
 * NTCP2: Add key validity check
 * Plugins: Don't auto-update in test mode
 * Ratchet: Use correct method for Elg2 keygen
 * Susimail: Include attachment sizes in displayed draft size
 * Transports: Don't flood huge RIs
 * Util:
   - Catch OOM in timer
   - Add 2nd order comparison in ObjectCounterUnsafe sort

2023-12-18 2.4.0 (API 0.9.61) released

2023-12-15 idk
 * Pull translations from Transifex
 * Fix updating router profile in SearchUpdateReplyFoundJob

2023-12-15 zzz
 * Pull translations from Transifex

2023-12-14 zzz
 * Console: Whitespace fixes on config pages

2023-12-08 zzz
 * Installer: Fix rare misidentification of OS

2023-12-07 zzz
 * Susimail:
   - Fix placement of bottom page nav
   - Show spam flags for all in spam folder
   - Dark theme fixes

2023-12-06 zzz
 * Susimail:
   - Flush output to fix truncated mails
   - Close output for attachments
   - Fix setting encoding for attachments
   - Set length for binary encoding

2023-12-05 zzz
 * Build: poupdate-source
 * i2ptunnel: Remove dup headers in error pages

2023-12-02 zzz
 * Console: Fix sidebar not immediately showing results of /configsidebar changes
 * Susimail:
   - Fix binary content-encoding
   - Fix incorrect "previous" icons

2023-12-01 zzz
 * Console:
   - Clear out "proxy must be running" status after success
   - Don't lose tabs in log messages
   - Fix HTML errors on /configupdate
   - Fix sidebar not immediately showing results of manual update check
   - Prevent overflow of sidebar status
 * i2psnark: Change js mime type as per RFC 9239

2023-11-29 zzz
 * Build: Handle QUALIFIER
 * UPnP:
   - Fix missing port in Host header causing failures on libupnp-based devices
   - Fix handing of multiple IGDs
   - Improve logging about multiple IGDs
   - Make case of HTTP headers more standard

2023-11-27 zzz
 * i2psnark: Delay bandwidth limits check briefly

2023-11-21 zzz
 * Addressbook: Workaround for i2p-projekt.i2p etag bug (Gitlab #454)
 * Console: Don't list inner classes on /configlogging
 * i2ptunnel: Add thread number to server thread names
 * Profiles: Increase congestion cap penalties (Gitlab #412)

2023-11-19 zzz
 * Router: Don't log events in test mode

2023-11-18 zzz
 * i2psnark: Uncomment and fix local torrent file picker

2023-11-17 zzz
 * Console: Add "required" to input fields where necessary
 * i2ptunnel: Edit and wizard form improvements

2023-11-16 zzz
 * Build: Force build to die on fatal JspC errors

2023-11-15 zzz
 * i2psnark:
   - Handle metainfo url-list as single byte string
   - Increase comment bucket size to reduce duplicates
   - Sort tracker list on details page

2023-11-12 zzz
 * Banlist: Throw if banning far in the past, to catch bugs
 * Router: Temp. ban routers publishing in the future
 * Sybil: Don't ban NAT64 addresses

2023-11-11 zzz
 * Console: Sybil page CSS fixes
 * Router: Fix congestion cap publishing

2023-11-10 zzz
 * i2ptunnel: Exempt tunnel name from XSS filter (Gitlab #467)
 * NetDB: Lookup handler/throttler fixes
   - Allow limited lookups when non-ff, but still disallow expl. lookups
   - Remove unnecessary banlist checks in handler
   - Add lower non-ff limit in throttler
   - Fix check for our RI
   - Remove now-unused stats

2023-11-09 zzz
 * Console: Fix published LS count on the debug LS tab

2023-11-08 zzz
 * NetDB: Fix and deprecate unused store() method

2023-11-07 zzz
 * Translations: Fix config file for v3

2023-11-04 zzz
 * NetDB: Type changes (Gitlab #402)
   - Revert ctx.netDb() return type change
   - Revert all DummyNetworkDatabaseFacade changes
   - Add DummyNetworkDatabaseSegmentor
   - FNDS/SNDF return type changes
   - Add back casts of netDb() calls to FNDF where necessary
   - Fix console NPE when using DummyNDF

2023-11-03 zzz
 * Console: RTL CSS tweaks

2023-11-02 zzz
 * Console:
   - Use RTL CSS for Persian
   - Profiles definitions CSS fixes
 * NetDB: Enforce no RIs in subdbs (Gitlab #465)
   - Throw IAE if attempting to store/publish RI to subdb
   - Log warnings if attempting to lookup RI in subdb
   - Revert changes to createPeerSelector()
   - Revert peer selector changes in SearchJob and StoreJob
   - Use common PeerSelector and KBucketSet for all dbs
   - Revert/fix FloodfillVerifyStoreJob to looukp RIs in the main DB
   - Don't start ExpireRoutersJob in subdbs
   - Revert change in InboundMessageDistributor that was looking up RI in subdb
   - Remove KNDF.isMainDb(), replace with !isClientDb()

2023-10-29 zzz
 * Console: Netdb tab fixes and cleanup (Gitlab #465)

2023-10-28 zzz
 * i2ptunnel:
   - Remove nonstandard Proxy-Connection headers (Gitlab #452)
   - Fix gzip footer check in GunzipOutputStream (Gitlab #458)
 * NetDB: Fix lifecycle issues for subsessions (Gitlab #460, #406)
   - Don't create subdb for subsession and lose ref for primary subsession;
   - Simplify CCR.getFNDF() to simply return the subdb or null; nothing else is necessary
   - Do not unpublish LS from main db on session shutdown; not necessary, it is not in there

2023-10-25 zzz
 * Console: Tweaks to advanced peers summary bar section

2023-10-24 zzz
 * Netdb: Subdb lifecycle fixes (Gitlab #406)
   - Disable RefreshRoutersJob for subdbs
   - Cancel ExpireRoutersJob and ExpireLeasesJob at netdb shutdown
   - Do not run ExpireRoutersJob at shutdown for subdbs
   - Do not create _exploreKeys HashMap for subdbs, and add checks for subdbs
   - Convert NegativeLookupCache timer to SimpleTimer2 so we may cancel it
   - Add method to cancel NegativeLookupCache timer; cancel it when netdb shuts down

2023-10-21 zzz
 * Tests: Disable console scala tests in gradle tests

2023-10-21 zzz
 * SAM: Reset incoming socket if no subsession is matched (Gitlab #456)
 * Tests: Exclude BuildMessageTestStandalone from gradle tests

2023-10-20 zzz
 * Build: Gradle build fixes

2023-10-12 zzz
 * i2ptunnel: HTTPResponseOutputStream cleanups

2023-10-10 zzz
 * Add ramble.i2p to hosts.txt
 * i2psnark:
   - Shutdown incomplete torrents first
   - Add shutdown button to systray (standalone only)

2023-10-09 zzz
 * Console: Fix visibility of radio/checkboxes (light theme)

2023-10-03 zzz
 * SSU2: Prevent rare IAE in peer test timer (Gitlab #433)

2023-09-29 zzz
 * i2psnark: Search box CSS tweaks when iframed (Gitlab #448)
 * SAM: Fix accept after soft restart (Gitlab #399)
 * Transport: Disable SSU1 by default (Gitlab #427)

2023-09-27 zzz
 * Console: Change all DOCTYPEs to standard html (Gitlab #426)
 * Debian: Change JRE dependency order (Gitlab #443, Debian #1024461)
 * i2psnark: Prevent start-all from within search results erroring (Gitlab #445)
 * NTCP2: Fix updating address on transition to firewalled (Gitlab #435)
 * SSU2: Fix uncaught IAE caused by itags with zero values (Gitlab #415)
 * Transport: Fix NPE during soft restart (Gitlab #437)

2023-06-28 2.3.0 (API 0.9.59) released

2023-06-28 idk
 * Cache stores of multihomed leaseSets when stored from multihome peers,
   and if our local leaseSet is not in the keyspace return the multihome instead
 * When updating a leaseSet because receiving it as published always make a
   complete copy of the leaseSet before merging the flags.
 * Rate-Limit lookups

2023-05-29 idk
 * Adds "virtual contexts" to bloom filter, where each entity that
   passes an i2np message to the bloom filter xor's the messageID with a random, local value.
   credit Xe Iaso for discovering the issue, obscuratus for the solution

2023-04-12 2.2.1 (API 0.9.58) released

2023-04-12 idk
 * Fix missing Java options in docker/rootfs/startapp.sh
 * Detect when running in Podman instead of regular Docker
 * Update Tor Browser User-Agent String
 * Update local GeoIP database
 * Remove invalid signing keys from old installs
 * Update Tomcat version in Ubuntu Lunar and Debian Sid

2023-03-13 2.2.0 (API 0.9.58) released

2023-03-13 idk
 * Send and check target destination in first streaming SYN packet

2023-02-18 zzz
 * DTG: Remove "Start I2P" menu item in non-router context
 * Sybil: Don't catch all the i2pds publishing ::1

2023-02-17 zzz
 * Console: Add legend for congestion caps (proposal 162)

2023-02-16 zzz
 * Transports: Add new inbound connection throttler

2023-02-15 zzz
 * Router:
   - Disable Sybil analysis when in test mode
   - Store feed blocklist in main array for efficiency
 * Tunnels: Re-enable using U routers in some expl. tunnels

2023-02-13 zzz
 * Profiles:
   - Change the new-router bonus to a penalty
   - Remove unused failing peers map

2023-02-12 zzz
 * Console: Reduce max age of displayed profiles
 * NetDB:
   - Don't create profile unless peer is reachable
   - Store handler updates
 * Profiles:
   - Adjust capacity for send success/failure
   - Don't create new profile on message or lookup failures
   - Downrate capacity of slow/unreachable peers
   - Limit storage and memory usage
 * Router: Increase min version for tunnels and netdb to 0.9.51
 * Tunnels: Don't build through U routers

2023-02-11 zzz
 * NetDB:
   - Expiration tweaks
   - Increase flood thottle time

2023-02-10 zzz
 * Router: Tighten skew calculation window

2023-02-09 zzz
 * DTG: Support notification disable/enable in non-router context
 * NetDB:
   - Don't lookup before dropping after shutdown initiated
   - Improve efficiency of ExpireRoutersJob
 * Profiles: Don't delete old profiles from disk until 90m uptime

2023-02-08 zzz
 * Console:
   - Add routing key to router infos (advanced)
   - Debug page sockets table cleanup
   - Load router infos more efficiently
 * NetDB:
   - Don't explore if we have enough RIs
   - Further restrict what RIs we lookup before dropping
   - Implement faster RI expiration mode
   - Increase closest-floodfill search size
   - Reduce min RI expiration
   - Reduce max floodfill fail rate
   - Replace Set with List in ExpireLeasesJob for efficiency
   - Set max routers to load at startup
 * NTCP2:
   - Ban peers that ban us
   - Block IP on failed inbound
   - Increase temp. inbound IP block time
   - Route RI block of another router to InNetMessagePool
 * Router:
   - Don't set congestion cap at startup because of high job lag
 * Sybil:
   - Don't do pair distance check unless enough memory
   - Thread analyzer at reduced priority
 * Transports: Check RI in handshake for matching IP
 * Tunnels: Load RIs more efficiently in peer selector

2023-02-04 zzz
 * Router:
   - Continue work on congestion caps (proposal 162)
   - Stat cleanup

2023-02-03 zzz
 * i2psnark: Fix failure on torrents with '#' in the name
 * Util: Fix check for illegal chars in storeProps()

2023-02-01 zzz
 * Console: Don't list same client SKM twice on /debug for subsessions
 * Profiles:
   - Count all build rejections in tunnel history
   - Remove 30m tunnel history rates
 * Ratchet: Don't bundle LS with ratchet ACK

2023-01-30 zzz
 * Blocklist:
   - Don't maintain IPv6 blocklist unless we have an IPv6 address
   - Don't read in same-country blocklist unless configured or in strict country
 * NTCP2: Ensure we publish a "6" address on transition to firewalled
 * Streaming: Refactor sig checking
 * Tunnels:
   - Refactor peer selection
   - Improve expl. build success in well-connected routers during congestion
 * Util: Add experimental config to bypass Fortuna and just use /dev/random

2023-01-27 zzz
 * Console: Debug page cleanups
 * Tools: Add CLI reseed test
 * Tunnels: Reduce grace period from 120 to 90 sec.

2023-01-26 zzz
 * Console: Add revision and build date to version info
 * i2psnark: Search fixes

2023-01-25 zzz
 * Util: New thread-unsafe version of ObjectCounter

2023-01-24 zzz
 * Router: Preliminary support for congestion caps (proposal 162)

2023-01-23 zzz
 * i2psnark standalone: Fix running from outside the directory

2023-01-22 zzz
 * Build: Fix list of changed files in manifests
 * i2psnark: Add max files per torrent config

2023-01-21 zzz
 * Console:
   - Remove ERR- and WARN- prefixes from status strings
   - Catch graph error in Docker (Gitlab #383)
 * i2psnark: Search box CSS
 * NTCP: Do not rebind internal port if only SSU external port changed
 * SSU:
   - Eliminate Symmetric NAT errors for "full cone" NATs
   - Fix rare peer test NPE
   - Fix initial SSU2 MTU when SSU1 disabled

2023-01-19 zzz
 * Build: Add i2psnark-release target

2023-01-18 zzz
 * i2psnark: Search CSS and JS

2023-01-17 zzz
 * i2psnark:
   - Add basic search box
   - Recognize more clients
 * i2ptunnel: Fix typo for SSL outproxy host

2023-01-15 zzz
 * Console:
   - Fix displayed BPS for SSU peers
   - Add netdb search by introducer count
 * i2ptunnel:
   - Interrupt client tunnel build when stop button is clicked
   - Return error message from IRC client on failure to build tunnels
   - Return 503 from HTTP client on failure to build tunnels
   - Return error code from SOCKS client on failure to build tunnels


----------------

EARLIER HISTORY IS AVAILABLE IN THE SOURCE PACKAGE